package install.doc.examples;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import javax.activation.DataHandler;
import javax.activation.FileDataSource;
import javax.xml.namespace.QName;
import javax.xml.ws.soap.MTOMFeature;

import com.elpical.jclaro.inspector.ws.client.IspImpl;
import com.elpical.jclaro.inspector.ws.client.IspImplService;
import com.elpical.jclaro.pshopinspector.client.InspectorSession;

public class InspectorClaroWebservices_example {
	
	public static IspImpl getPort(String hostname, int portnumber,int timeout,boolean asMTOM) throws Exception {
		URL url = null;
		URL baseUrl;
		baseUrl = com.elpical.jclaro.inspector.ws.client.IspImplService.class.getResource(".");
		url = new URL(baseUrl, "http://"+hostname+":"+portnumber+"/jclaroinspectorjaxws/job?wsdl");
		IspImplService anis = new IspImplService(url, new QName("http://server.ws.inspector.jclaro.elpical.com/", "IspImplService"));
		IspImpl port;
		if (asMTOM)
			port = anis.getIspImplPort(new MTOMFeature(true,8000));
		else
			port = anis.getIspImplPort();

		if (port==null)
			throw new Exception("Inspector getPort can not be retrieved");

		return port;
	}

	public static void main(String[] args) throws Exception {
		System.out.println("Starting webservices example");

		//WebServices properties 
//		System.setProperty("javax.xml.stream.XMLEventFactory","com.sun.xml.stream.events.ZephyrEventFactory");
//		System.setProperty("javax.xml.stream.XMLInputFactory","com.sun.xml.stream.ZephyrParserFactory");
//		System.setProperty("javax.xml.stream.XMLOutputFactory","com.sun.xml.stream.ZephyrWriterFactory");


		try {
			IspImpl port = getPort("homeroom",8080,10,true);	
			
			InspectorSession.getInstance().doLogin("jan", "XXXXXX", null);
			
			int clientid = (int)(Math.random()*Integer.MAX_VALUE);
			port.addClientID(InspectorSession.getInstance().getUserToken(), clientid);
			ArrayList<String> watchChannels = new ArrayList<String>();
			watchChannels.add("all");
			Runtime runtime = Runtime.getRuntime();

			do {
				if (port.isQueueUpdateAvailable(InspectorSession.getInstance().getUserToken(), clientid)) {
					List<Integer> idlist = port.getQueue(InspectorSession.getInstance().getUserToken(), clientid,watchChannels);
					System.out.println("idlist"+idlist);
					if (!idlist.isEmpty()) {
						int id = idlist.get(0);
						if (!port.isInUse(InspectorSession.getInstance().getUserToken(), id)) {
							long t0 = System.currentTimeMillis();
							System.out.println("processing inspector object:"+id);
							port.setInUseByUser(InspectorSession.getInstance().getUserToken(), id, "Frans");
							String orgname = port.getOriginalFileName(InspectorSession.getInstance().getUserToken(), id);
							String prcname = port.getProcessedFileName(InspectorSession.getInstance().getUserToken(), id);
							File orgfile = new File("C:/Downloads/"+orgname); 
							File prcfile = new File("C:/Downloads/"+prcname); 

							System.out.print("download original imagefile from server...");
							DataHandler dhimg = (DataHandler) port.getOriginalFile(InspectorSession.getInstance().getUserToken(), id);
							FileOutputStream fos = new FileOutputStream(orgfile);
							OutputStream output = new BufferedOutputStream(fos);
							
							try {
								dhimg.writeTo(output);
							}
							catch (Exception e) {
					        	System.out.println(e.toString() + " InspectorClaroWebservices_example main 1");
					        }
							finally {
								try {
									output.close();
								}
								catch (Exception e) {
						        	System.out.println(e.toString() + " InspectorClaroWebservices_example main 2");
						        }
								
								try {
									fos.close();
								}
								catch (Exception e) {
						        	System.out.println(e.toString() + " InspectorClaroWebservices_example main 3");
						        }
							}
							
							long t1 = System.currentTimeMillis();
							
							System.out.print("done\ndownload processed imagefile from server...");
							dhimg = (DataHandler) port.getProcessedFile(InspectorSession.getInstance().getUserToken(), id);
							fos = new FileOutputStream(prcfile);
							output = new BufferedOutputStream(fos);
							
							try {
								dhimg.writeTo(output);
							}
							catch (Exception e) {
					        	System.out.println(e.toString() + " InspectorClaroWebservices_example main 4");
					        }
							finally {
								try {
									output.close();
								}
								catch (Exception e) {
						        	System.out.println(e.toString() + " InspectorClaroWebservices_example main 5");
						        }
								
								try {
									fos.close();
								}
								catch (Exception e) {
						        	System.out.println(e.toString() + " InspectorClaroWebservices_example main 5");
						        }
							}
							
							long t2 = System.currentTimeMillis();
							
							System.out.print("done\nupload processed imagefile to server...");
							dhimg = new DataHandler(new FileDataSource(prcfile));
							port.setProcessedFile(InspectorSession.getInstance().getUserToken(), id,dhimg);
							System.out.print("done\n");
							port.useInspectedFileProcessed(InspectorSession.getInstance().getUserToken(), id, "Frans");
							long t3 = System.currentTimeMillis();
							System.out.println("(t0 t1)="+(t1-t0));
							System.out.println("(t1 t2)="+(t2-t1));
							System.out.println("(t2 t3)="+(t3-t2));
							long used1 = runtime.totalMemory()-runtime.freeMemory();
							long free = runtime.maxMemory()-used1;
							System.out.printf("CurrentMemory free:%d (%3.0f MB)\n",free,(float)(free/1000000));

						}
					}
				}
				System.gc();
				Thread.sleep(5000);
				long used1 = runtime.totalMemory()-runtime.freeMemory();
				long free = runtime.maxMemory()-used1;
				System.out.printf("CurrentMemory free:%d (%3.0f MB)\n",free,(float)(free/1000000));
				
			} while(true);

		} catch (Exception e) {
			System.out.println("Exception:"+e);
		}

		System.out.println("Finshised webservices example");
	}
}